function(input, output, session) {
  observeEvent(
    {
      input$display_position_full_range #special-purpose for MSA
      input$logoplot_colour_scheme
      input$switch_target
    },
    {
      # C O M P A T I B I L I T Y
      #gene=input$switch_target
      #drug=target_map[[gene]]
      merged_df3=cbind(get(paste0(input$switch_target, '_merged_df3')))
      
      position_max=max(merged_df3[['position']])
      position_min=min(merged_df3[['position']])
      min_ligand_distance=min(merged_df3$ligand_distance)
      max_ligand_distance=max(merged_df3$ligand_distance)
      # FIXME: these are IMPORTANT
      # # add "pos_count" position count column
      # merged_df3=merged_df3 %>% dplyr::add_count(position)
      # merged_df3$pos_count=merged_df3$n
      # merged_df3$n=NULL
      # 
      mutable_df3 = cbind(merged_df3)
      unified_msa = get(paste0(input$switch_target, '_unified_msa'))
      # 
      # # re-sort the dataframe according to position count
      sorted_df = cbind(merged_df3)
      sorted_df = sorted_df %>% arrange(pos_count)
      
      # 
      outdir = paste0("~/git/Data/", drug, '/output/')
      indir  = paste0("~/git/Data/", drug , "/input/")
      # 
      # source("~/git/LSHTM_analysis/scripts/plotting/logo_data_msa.R") # probably unnecessary...
      
      #  source("~/git/LSHTM_analysis/scripts/plotting/get_plotting_dfs.R")
      
      #### nasty special-purpose merged_df3 variants ####
      # FIXME: SLOW
      # corr_plotdf = corr_data_extract(
      #   merged_df3
      #   , gene = gene
      #   , drug = drug
      #   , extract_scaled_cols = F
      # )
      
      #input$stability_snp_param
      
      updateSliderInput(
        session, 
        "display_position_range",
        min = position_min,
        max = position_max
        #, value = c(position_min, position_min+150)
      )
      updateSliderInput(
        session,
        "display_position_full_range",
        min = 1, 
        max = position_max #, 
        # value = c(position_min, position_min+150)
      )
      updateNumericInput(session, "selected_logop_snp_position", min = position_min, max = position_max, value = position_min)
      updateNumericInput(session, "selected_logop_ed_position", min = position_min, max = position_max, value = position_min)
      updateNumericInput(session, "corr_lig_dist", min = min_ligand_distance, max = max_ligand_distance, value = min_ligand_distance)
      
      stability_colname      = stability_boxes_df[stability_boxes_df$stability_type==input$stability_snp_param,"stability_colname"]
      outcome_colname        = stability_boxes_df[stability_boxes_df$stability_type==input$stability_snp_param,"outcome_colname"]
      
      display_position_range = input$display_position_range
      plot_min=display_position_range[1]
      plot_max=display_position_range[2]
      
      display_position_full_range = input$display_position_full_range
      full_range_min=display_position_full_range[1]
      full_range_max=display_position_full_range[2]
      
      logoplot_colour_scheme = input$logoplot_colour_scheme
      omit_snp_count = input$omit_snp_count
      
      print(paste0('Plotting positions between: ', plot_min, ' and ', plot_max))
      
      subset_mutable_df3=mutable_df3[(mutable_df3$position>=plot_min & mutable_df3$position <=plot_max),]
      
      subset_mutable_df3=mutable_df3[(mutable_df3$position>=plot_min & mutable_df3$position <=plot_max),]
      subset_sorted_df=sorted_df[(sorted_df$position>=plot_min & sorted_df$position <=plot_max),]
      
      
      
      #### LogoPlotMSA/Logo Plot ED ####
      output$LogoPlotMSA = renderPlot(
        LogoPlotMSA(target=input$switch_target,
                    plot_positions=full_range_min:full_range_max,
                    my_logo_col = logoplot_colour_scheme,
                    aa_pos_drug = aa_pos_drug,
                    active_aa_pos = active_aa_pos,
                    aa_pos_lig1 = aa_pos_lig1,
                    aa_pos_lig2 = aa_pos_lig2,
                    aa_pos_lig3 = aa_pos_lig3
        )
      )
    }
  )
}